//general tests

#include "../miniGrail.h"

#include <iostream>
int main()
{

////////array test

//store and []
	mGArray<mGArray<int> *> a;
	mGArray<int> * p = new mGArray<int>();

	for (int aa = 0; aa < 5; aa++)
		a += p;

	mGArray<mGArray<int> *> b(a);

	a[2] = NULL;

	for (int aa = 0; aa < 5; aa++)
		std::cout << a[aa] << std::endl << b[aa] << std::endl << std::endl;

	delete p;

	a.clear();

//search
	mGArray<int> * pp = new mGArray<int>();
	for (int aa = 0; aa < 5; aa++)
		(*pp) += aa;

	std::cout << pp->member(2) << "," << (*pp).member(9) << std::endl;

	(*pp) -= 2;
	for (int a = 0; a < pp->size(); a++)
		std::cout << (*pp)[a];

	std::cout << std::endl;

	(*pp) += 1;
	(*pp) += 1;
	std::cout << std::endl;
	for (int a = 0; a < pp->size(); a++)
		std::cout << (*pp)[a];

	(*pp).removeAll(1);

	std::cout << std::endl;

	for (int a = 0; a < pp->size(); a++)
		std::cout << (*pp)[a];
//std::cout<<(*pp);

	std::cout << std::endl;
	(*pp) += 1;
	(*pp) += 2;
	pp->quickSortWithSort();
	for (int a = 0; a < pp->size(); a++)
		std::cout << (*pp)[a];

	std::cout << std::endl;

	(*pp) += 2;
	pp->heapSort();

	std::cout << std::endl;
	for (int a = 0; a < pp->size(); a++)
		std::cout << (*pp)[a];

	mGArray<int> aaa(*pp);

	std::cout << std::endl;
	for (int a = 0; a < pp->size(); a++)
		std::cout << (aaa)[a];
	aaa = (*pp);
	std::cout << std::endl;
	for (int a = 0; a < pp->size(); a++)
		std::cout << (aaa)[a];

	std::cout << std::endl;
	(*pp) += 1;
	(*pp) += 2;
	pp->quickSortWithQsort();
	for (int a = 0; a < pp->size(); a++)
		std::cout << (*pp)[a];

	std::cout << std::endl;

	std::cout << (aaa == (*pp)) << "," << (aaa < (*pp)) << (aaa > (*pp))
			<< std::endl;

	//test of transitions:
	std::cout << "tests transitions" << std::endl;

	mGArray<mGTransition> insts;

	for (int a = 0; a < 30; a++)
	{
		mGTransition t;

		t.setStart(a % 6);

		t.setLabel(a);

		t.setEnd(a % 4);

		insts += t;
	}

	insts.heapSort();

	for (int a = 0; a < insts.size(); a++)
	{

		std::cout << insts[a] << endl;
	}

	cout << endl << endl << "nfa analyze test" << endl;
	mGNFA nfa;
	mGTransition t(1, 2, 3);
	nfa.addTransition(t);
	mGTransition t2(1, 2, 4);
	nfa.addTransition(t2);
	mGTransition t3(3, 4, 5);
	nfa.addTransition(t3);
	mGState s(1);
	nfa.addStart(s);
	mGState f(5);
	nfa.addFinal(f);
	mGMachineAnalyze(nfa);
	cout << nfa;
	cout << "The first transition is" << nfa[0] << endl;

	cout << "now attach" << std::endl;
	nfa.attach();

	mGSet<mGState> set;
	nfa.gatherStates(set);
	for (int a = 0; a < set.size(); a++)
	{
		cout << "key" << set[a] << std::endl;
		for (int b = 0; b < nfa.getTransitionsStartFrom(set[a]).size(); b++)
			cout << (nfa.getTransitionsStartFrom(set[a]))[b] << std::endl;

	}

	DEBUG_TRIGGER(DEBUG_mGNFAtoDFA_Set); //ENBALE DEBUG FOR THIS ALGO
	DEBUG_TRIGGER(DEBUG_mGArray_getIntersection);
	DEBUG_TRIGGER(DEBUG_mGArray_member);

	mGDFA d;
	mGNFAtoDFA_Set(nfa, d);

	std::cout << d;

	return 0;
}
