/* 
 file: mGAlgorithms.h 
 Project: miniGrail   
 License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html 
 Created by: by Rui Zhou 
 Maintainer: Cezar Campeanu <ccampeanu@upei.ca> 
                     
*/
                     
#include "mGDFAMinimize_Hopcroft/mGDFAMinimize_Hopcroft.h"
#include "mGDFAMinimize_Moore/mGDFAMinimize_Moore.h"
#include "mGDFAMinimize_TBF/mGDFAMinimize_TBF.h"
#include "mGFlToNFA/mGFlToNFA.h"
#include "mGIsComp/mGIsComp.h"
#include "mGIsDeterm/mGIsDeterm.h"
#include "mGMachineAnalyze/mGMachineAnalyze.h"
#include "mGNFAComp/mGNFAComp.h"
#include "mGNFAEnum/mGNFAEnum.h"
#include "mGNFAUnion/mGNFAUnion.h"
#include "mGNFAtoDFA/mGNFAtoDFA_Set.h"
#include "mGNFAtoDFA_mG/mGNFAtoDFA_mG.h"
#include "mGDFAMinimize_Hopcroft/mGDFAMinimize_Hopcroft.cpp"
#include "mGDFAMinimize_Moore/mGDFAMinimize_Moore.cpp"
#include "mGDFAMinimize_TBF/mGDFAMinimize_TBF.cpp"
#include "mGFlToNFA/mGFlToNFA.cpp"
#include "mGIsComp/mGIsComp.cpp"
#include "mGIsDeterm/mGIsDeterm.cpp"
#include "mGMachineAnalyze/mGMachineAnalyze.cpp"
#include "mGNFAComp/mGNFAComp.cpp"
#include "mGNFAEnum/mGNFAEnum.cpp"
#include "mGNFAUnion/mGNFAUnion.cpp"
#include "mGNFAtoDFA/mGNFAtoDFA_Set.cpp"
#include "mGNFAtoDFA_mG/mGNFAtoDFA_mG.cpp"
