/*
    file: mGMachineAnalyze.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


    This algorithm is to analyze a  finite machine
    
*/
using namespace std;

void mGMachineAnalyze(const mGNFA& fm)
{
	cout << "Analyzing DFA:" << endl;

	mGSet<mGTransition> ts = fm.getTransitions();

	cout << "This machine has" << ts.size() << " transitions" << endl;

}
