/*
    file: mGBackBone.h 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


 This is the head file of miniGrail BackBone
 Include this to use miniGrail data structures
 */

#include "assert.h"

#include "fstream"

#include <limits>

#include "mGDefines.h"

#include "mGConstants/mGConstants.h"

#include "mGArray/mGArray.h"

#include "mGSet/mGSet.h"

#include "mGMap/mGMap.h"

#include "mGInt/mGInt.h"

#include "mGIO/mGOstream.cpp"

#include "mGArray/mGArray.cpp"

#include "mGSet/mGSet.cpp"

#include "mGMap/mGMap.cpp"

#include "mGInt/mGInt.cpp"

