/*
    file: mGSet.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

 
 This is the implementation of methods in mGSet


 */
using namespace std;
#include <set>
//#include <vector>

//#include <algorithm>

//copy from  an mGArray
template<class T>


//todo:  use a std::set????


/*
 mGSet<T>::mGSet(const mGArray<T>& a):v(a.v)	//question???
 {
 set<T> tempSet;
 for(a=0;a<v.size();a++)
 {
 tempSet.insert(v[a]);
 }
 v.clear();
 for(int a=0;a<tempSet.size();a++)
 {
 v.push_back(tempSet[a]);
 }
 sorted=true;//because std::set class take care of sorting
 }
 */

mGSet<T>::mGSet(const mGArray<T>& a)
{
	(*this) = a; //call assignment
}

//assign from mGArray
template<class T>
mGSet<T>& mGSet<T>::operator=(const mGArray<T>& a)
{
	set<T> tempSet;
	for (int i = 0; i < a.size(); i++)
	{
		tempSet.insert(a[i]);
	}
	this->v.clear();

	typename set<T>::iterator it;
	for (it = tempSet.begin(); it != tempSet.end(); it++)
	{
		this->v.push_back(*it);
	}
	this->sorted = true; //because std::set class take care of sorting
	return *this;
}

//add element
template<class T>
mGSet<T>& mGSet<T>::operator+=(const T& e)
{
	if (this->member(e) < 0)
	{
//question?  if sorted ///
		this->v.push_back(e);

		this->sorted = false;
	}

	return *this;
}
template<class T>
mGSet<T>& mGSet<T>::operator+=(const mGSet<T>& set)
{
	for (int a = 0; a < set.size(); a++)
	{
		T temp = set[a];
		if (this->member(temp) < 0)
		{
			this->v.push_back(temp);
			this->sorted = false;

		}

	}
	return *this;

}
template<class T>
mGSet<T>& mGSet<T>::disjoint_union(const T& e)
{
	this->v.push_back(e);

	this->sorted = false; //question: two statements, inline?

	//TODO: IF THE ARRAY IS SORTED AND WE ADD A ELEMET BIGGER THAN LAST ONE IN ARRAY
	//WE KEEP SORTED AS TRUE?

	return *this;
}

template<class T>
mGSet<T>& mGSet<T>::disjoint_union(const mGSet<T>&s)
{

	for (int a = 0; a < s.size(); a++)
	{
		this->v.push_back(s[a]);
	}
	this->sorted = false;
	return *this;
}

template<class T>
mGSet<T>&
mGSet<T>::intersect(mGSet<T>& s1, mGSet<T>& s2)
{

	this->clear();
// sort s1, s2
	s1.heapSort();
	s2.heapSort();
	// if s1 is below s2, return
	if (s1[s1.size() - 1] < s2[0])
		return *this;

	//now use the std intersect

	set_intersection(s1.v.begin(), s1.v.end(), s2.v.begin(), s2.v.end(),
			back_inserter(this->v));
	this->sorted = true; //TODO IS THIS GURARRENTED ?
	//TODO  MOVE THIS TO ARRAY?
	return *this;

}
