/*
    file: fcmenum.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

*/

void fcmenum()
{

	mGDFCA dfca;
	int num_to_enum = 100; //by default enum 100

	//handle -n number
	if (args.size() >= 2)
	{
		if (args.member("-n") >= 0)
		{
			num_to_enum = atoi(args[args.member("-n") + 1].c_str());
			args -= args[args.member("-n") + 1];
			args -= "-n";
		}

	}

	//if get data from file
	if (args.size() > 0)
	{
		fstream fio;
		fio.open(args[0].c_str(), ios::in);
		if (!fio)
		{
			cerr << CantOpenMsg << args[0] << "\n";
			exit(1);
		};
		fio >> dfca;
		fio.close();
	}
	else
	{
		cin >> dfca;
	}

	mGArray<mGString> arr;

	mGNFAEnum(dfca, arr, num_to_enum, dfca.getL());

	for (int a = 0; a < arr.size(); a++)
	{
		if (a < num_to_enum && arr[a].size()<=dfca.getL() )
			std::cout << arr[a] << std::endl;

	}

}
