/*
    file: fmcomp.cpp 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>

*/

void fmcomp()
{

	mGDFA nfa;

	//if get data from file
	if (args.size() > 0)
	{
		fstream fio;
		fio.open(args[0].c_str(), ios::in);
		if (!fio)
		{
			cerr << CantOpenMsg << args[0] << "\n";
			exit(1);
		};
		fio >> nfa;
		fio.close();
	}
	else
	{
		cin >> nfa;
	}

	mGNFAComp(nfa);
	cout << nfa;

}
