/*
    file: mGState.h 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


 This class is the basic state in a  machine
*/

#ifndef _MGSTATE

using namespace std;
//question? how many times should I declare this

//for compile	
//class mGTransition;
//#include <iostream>
class mGState
{
protected:
	int number;
	//bool start;
	//bool final;
	//mGSet<mGTransition*>  attachedTransitons;  

public:
//constructor copy  and deconstroctor
	mGState();
	mGState(int);
	mGState(const mGState& a);
	~mGState()
	{/*nothing */
	}
	;

//assign
	mGState& operator=(const mGState&);
//compare
	inline bool operator==(const mGState& s) const
	{
		//std::cout << number << "**" << s.number << std::endl;

		return number == s.number;
	}
	inline bool operator!=(const mGState& s) const
	{
		return number != s.number;
	}

	inline bool operator<(const mGState& s) const
	{
		return number < s.number;
	}
	inline bool operator>(const mGState& s) const
	{
		return number > s.number;
	}

//get value
	inline int getNumber() const
	{
		return number;
	}
//inline  bool isStart() const
	//  {return start;}
//inline  bool isFinal() const
	//  {return final;}

//set value
	inline void setNumber(int n)
	{
		number = n;
	}
//inline void setStart(bool b)
//    {start=b;}
//inline void setFinal(bool b)
	//  {final=b;}
	/*
	 inline void attach(mGTransition * t)
	 {
	 attachedTransitons+=t;
	 }
	 inline void deAttach(mGTransition * t)
	 {
	 attachedTransitons-=t;
	 }
	 */
};
#define _MGSTATE
#endif
