/*
    file: mGTheoryObjects.h 
    Project: miniGrail
    License: LGPLv2.1 http://www.gnu.org/licenses/lgpl-2.1.html

    Created by: by Rui Zhou
    Maintainer: Cezar Campeanu <ccampeanu@upei.ca>


 This is the head file including everything inside the theory objects folder
*/

#include "mGIO/mGSymbolTable.h"

#include "mGState/mGState.h"
#include "mGState/mGState.cpp"
inline istream& operator>>(istream&, mGState&);
inline void operator>>(string&, mGState&);
inline ostream& operator<<(ostream&, const mGState&);
#include "mGTransition/mGTransition.h"
inline istream& operator>>(istream&, mGTransition&);
inline void operator>>(string&, mGTransition&);
inline ostream& operator<<(ostream&, const mGTransition&);
#include "mGTransition/mGTransition.cpp"
#include "mGNFA/mGNFA.h"
#include "mGNFA/mGNFA.cpp"
inline istream& operator>>(istream&, mGNFA&);
inline ostream& operator<<(ostream&, const mGNFA&);
#include "mGDFA/mGDFA.h"
#include "mGDFA/mGDFA.cpp"
#include "mGDFCA/mGDFCA.h"
#include "mGDFCA/mGDFCA.cpp"



#include "mGString/mGString.h"
inline ostream& operator<<(ostream&, const mGString&);
inline void operator>>(string&, mGString&);
inline istream& operator>>(istream&, mGString&);
#include "mGLanguage/mGLanguage.h"
inline ostream& operator<<(ostream&, const mGLanguage&);
inline istream& operator>>(istream&, mGLanguage&);
#include "mGIO/mGIstream.cpp"
#include "mGIO/mGOstream.cpp"

